using Exferia_Aplicacion.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Informes.General;
using Exferia_Informes._0_Modelos;
using static Exferia_Aplicacion.General.Enumerados;
using Exferia_EntityFramework;
using Exferia_Aplicacion.Modelos_Existencias;

namespace Exferia_Informes._3_Vistas.Listados
{
    public class ABS_Listado_Movimientos_PorUbicacion : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_Movimientos_PorUbicacion()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //Delegacion
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Delegacion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Delegacion), "Delegacion", G_ENUM_TIPOSDATOS.TEXT, false, 150, true, false, true, false, "", null));

            //Almacen
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Almacen), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Almacen), "Almacen", G_ENUM_TIPOSDATOS.TEXT, false, 150, true, false, true, false, "", null));

            //Ubicacion
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Ubicacion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Ubicacion), "Ubicación", G_ENUM_TIPOSDATOS.TEXT, false, 150, true, false, true, false, "", null));

            //Fecha
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Fecha), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Fecha), "Fecha", G_ENUM_TIPOSDATOS.DATETIME, false, 90, true, true, true, false, "", null));

            //TipoDocumento
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.TipoDocumento), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.TipoDocumento), "Tipo de documento", G_ENUM_TIPOSDATOS.TEXT, false, 150, true, true, true, false, "", null));

            //TipoCompraVenta
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.TipoCompraVenta), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.TipoCompraVenta), "Tipo movimiento", G_ENUM_TIPOSDATOS.TEXT, false, 150, true, false, true, false, "", null));

            //Documento
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Documento), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Documento), "Documento", G_ENUM_TIPOSDATOS.LONG, false, 150, true, false, true, false, "", null));

            //Cantidad
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Cantidad), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Cantidad), "Cantidad", G_ENUM_TIPOSDATOS.DECIMAL, false, 100, true, false, true, false, "", null));

            //Calculada_Cantidad
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Calculada_Cantidad), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Calculada_Cantidad), "Cantidad (Existencias)", G_ENUM_TIPOSDATOS.DECIMAL, false, 150, true, false, true, false, "", null));

        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_INF_MOVIMIENTOSARTICULO);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_INF_MOVIMIENTOSARTICULO + "_PorUbicacion";
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_INF_MovimientosArticulos_Listado_Modelo.Fecha);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
